/*
    Copyright 2003 Nasif Akand (nasif@yifan.net)
    http://go.to/zipamp
    http://zipamp.virtualave.net

    This file is part of ZipAmp MP3 software.

    ZipAmp is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ZipAmp is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this code; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

//This module performs LCD operations for ZipAmp
//Nasif Akand

#ifndef __LCD_H__
#define __LCD_H__


/* change these definitions to adapt setting */

#define LCD_LINES           2     /* visible lines */
#define LCD_LINE_LENGTH  0x40     /* internal line length */

#define EN	PORTB.4
#define RS	PORTC.5
#define RW	PORTC.4
#define OutMode	DDRC=0xFF	//To send data to LCD
#define InMode	DDRC=0xF0	//To read data from LCD
#define Hi_Z	DDRC=0		//Leave port at hi-z stat
#define LCD	PORTC		//LCD data port
//Port setup:
//D4=PORTC0, D5=PORTC1, D6=PORTC2, D7=PORTC3
//R/W=PORTC4, RS=PORTC5, E=PORTB4


//void 	WaitTillLCDBusy();
//byte 	ReadByte();
void 	writechar(byte value);
void 	writestring(byte flash *strn);
void 	gotoxy(byte x, byte y);
void	InitLCD();
void    LCDclrscr();
void    writeNumber(word value);
void	blink(); 
void 	WriteByte(byte value);
//void 	clreol(byte line);
//void    spacer(byte x, byte y, byte value);
void 	SetSoundCg();
#endif
